<script lang="ts">
import { inject, ref } from 'vue';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import JDraggable from '@new-jira-clone/ui/src/components/drag-drop/JDraggable/JDraggable.vue';
import JResizer from '@new-jira-clone/ui/src/components/shared/JResizer';
import DialogBtn2 from './DialogBtn2.vue';

export default {
  components: {
    JDraggable,
    JResizer,
    DialogBtn2,
  },
  props: {
    dialogId: {
      type: Number,
      default: undefined,
    },
  },
  emits: ['close'],
  setup() {
    const isShowModalDialog = ref(false);
    const $dialog = inject('$dialog') as DialogPlugin;

    return {
      isShowModalDialog,
      initialPosition: $dialog.getInitialNonModalDialogPosition(),
    };
  },
};
</script>

<template>
  <JDraggable
    v-slot="dragProps"
    :initial-top="initialPosition.top"
    :initial-left="initialPosition.left"
  >
    <JResizer v-slot="resizerProps" axis-y v-bind="$attrs">
      <div v-bind="resizerProps" class="dialog-content">
        <div class="header" v-bind="dragProps">
          Draggable header
          <div
            class="close"
            @click="dialogId ? $dialog.close(dialogId) : $emit('close')"
            @keydown.enter="dialogId ? $dialog.close(dialogId) : $emit('close')"
          >
            <JDialogCloseIcon />
          </div>
        </div>
        <div class="body">
          Lorem ipsum dolor sit amet consectetur adipisicing elit. Iusto ipsam eius error
          accusantium aliquam voluptatum.

          <JButton class="mt-3" @click="isShowModalDialog = true">
            Show modal dialog
          </JButton>
        </div>

        <JDialog v-model="isShowModalDialog">
        <DialogBtn2 />
      </JDialog>
      </div>
    </JResizer>
  </JDraggable>
</template>

<style scoped lang="scss">
.dialog-content {
  display: flex;
  flex-direction: column;
  max-width: 500px;
  box-shadow: 0 11px 15px -7px #0003, 0 24px 38px 3px #00000024, 0 9px 46px 8px #0000001f;
  overflow: hidden;
  background-color: #fff;
}

.header {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 10px 0;
  text-align: center;
  border-bottom: 1px black solid;
}

.body {
  padding: 20px;
  height: 300px;
}

.grag {
  width: 24px;
  height: 24px;
  cursor: grab;
}

.close {
  display: inline-flex;
  margin-left: 6px;
}
</style>
